from rest_framework import serializers
from .models import (
    Guild,
    Player,
    Game,
    PlayerGameProfile,
    WowProfile,
    ValorantProfile,
    PlayerGuild,
)


class GuildSerializer(serializers.ModelSerializer):
    class Meta:
        model = Guild
        fields = ["id", "name", "tag", "creation_date"]
        read_only_fields = ["id", "creation_date"]


class PlayerSerializer(serializers.ModelSerializer):
    class Meta:
        model = Player
        fields = ["id", "name", "guild", "creation_date"]
        read_only_fields = ["id", "creation_date"]


class GameSerializer(serializers.ModelSerializer):
    class Meta:
        model = Game
        fields = ["id", "name", "creation_date"]
        read_only_fields = ["id", "creation_date"]


class PlayerGameProfileSerializer(serializers.ModelSerializer):
    class Meta:
        model = PlayerGameProfile
        fields = ["id", "player", "game", "creation_date"]
        read_only_fields = ["id", "creation_date"]


class WowProfileSerializer(serializers.ModelSerializer):
    class Meta:
        model = WowProfile
        fields = ["id", "player_game_profile", "level", "class_name", "creation_date"]
        read_only_fields = ["id", "creation_date"]


class ValorantProfileSerializer(serializers.ModelSerializer):
    class Meta:
        model = ValorantProfile
        fields = ["id", "player_game_profile", "rank", "creation_date"]
        read_only_fields = ["id", "creation_date"]


class PlayerGuildSerializer(serializers.ModelSerializer):
    class Meta:
        model = PlayerGuild
        fields = ["id", "player", "guild", "creation_date"]
        read_only_fields = ["id", "creation_date"]
